// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Batch.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Parameters for an ApplicationOperations.ActivateApplicationPackage
    /// request.
    /// </summary>
    public partial class ActivateApplicationPackageParameters
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ActivateApplicationPackageParameters class.
        /// </summary>
        public ActivateApplicationPackageParameters() { }

        /// <summary>
        /// Initializes a new instance of the
        /// ActivateApplicationPackageParameters class.
        /// </summary>
        /// <param name="format">The format of the application package binary
        /// file.</param>
        public ActivateApplicationPackageParameters(string format)
        {
            Format = format;
        }

        /// <summary>
        /// Gets or sets the format of the application package binary file.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "format")]
        public string Format { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Format == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "Format");
            }
        }
    }
}
