// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Capture Virtual Machine parameters.
    /// </summary>
    public partial class VirtualMachineCaptureParametersInner
    {
        /// <summary>
        /// Initializes a new instance of the
        /// VirtualMachineCaptureParametersInner class.
        /// </summary>
        public VirtualMachineCaptureParametersInner() { }

        /// <summary>
        /// Initializes a new instance of the
        /// VirtualMachineCaptureParametersInner class.
        /// </summary>
        /// <param name="vhdPrefix">the captured VirtualHardDisk's name
        /// prefix.</param>
        /// <param name="destinationContainerName">the destination container
        /// name.</param>
        /// <param name="overwriteVhds">whether it overwrites destination
        /// VirtualHardDisk if true, in case of conflict.</param>
        public VirtualMachineCaptureParametersInner(string vhdPrefix, string destinationContainerName, bool overwriteVhds)
        {
            VhdPrefix = vhdPrefix;
            DestinationContainerName = destinationContainerName;
            OverwriteVhds = overwriteVhds;
        }

        /// <summary>
        /// Gets or sets the captured VirtualHardDisk's name prefix.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "vhdPrefix")]
        public string VhdPrefix { get; set; }

        /// <summary>
        /// Gets or sets the destination container name.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "destinationContainerName")]
        public string DestinationContainerName { get; set; }

        /// <summary>
        /// Gets or sets whether it overwrites destination VirtualHardDisk if
        /// true, in case of conflict.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "overwriteVhds")]
        public bool OverwriteVhds { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (VhdPrefix == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "VhdPrefix");
            }
            if (DestinationContainerName == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "DestinationContainerName");
            }
        }
    }
}
