// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// SKU of application gateway
    /// </summary>
    public partial class ApplicationGatewaySku
    {
        /// <summary>
        /// Initializes a new instance of the ApplicationGatewaySku class.
        /// </summary>
        public ApplicationGatewaySku() { }

        /// <summary>
        /// Initializes a new instance of the ApplicationGatewaySku class.
        /// </summary>
        /// <param name="name">Name of application gateway SKU. Possible
        /// values include: 'Standard_Small', 'Standard_Medium',
        /// 'Standard_Large'</param>
        /// <param name="tier">Tier of application gateway. Possible values
        /// include: 'Standard'</param>
        /// <param name="capacity">Capacity (instance count) of application
        /// gateway</param>
        public ApplicationGatewaySku(string name = default(string), string tier = default(string), int? capacity = default(int?))
        {
            Name = name;
            Tier = tier;
            Capacity = capacity;
        }

        /// <summary>
        /// Gets or sets name of application gateway SKU. Possible values
        /// include: 'Standard_Small', 'Standard_Medium', 'Standard_Large'
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets tier of application gateway. Possible values include:
        /// 'Standard'
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "tier")]
        public string Tier { get; set; }

        /// <summary>
        /// Gets or sets capacity (instance count) of application gateway
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "capacity")]
        public int? Capacity { get; set; }

    }
}
