// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Inbound NAT pool of the loadbalancer
    /// </summary>
    [Microsoft.Rest.Serialization.JsonTransformation]
    public partial class InboundNatPoolInner : Microsoft.Azure.Management.Resource.Fluent.SubResource
    {
        /// <summary>
        /// Initializes a new instance of the InboundNatPoolInner class.
        /// </summary>
        public InboundNatPoolInner() { }

        /// <summary>
        /// Initializes a new instance of the InboundNatPoolInner class.
        /// </summary>
        /// <param name="protocol">Gets or sets the transport potocol for the
        /// endpoint. Possible values are Udp or Tcp. Possible values
        /// include: 'Udp', 'Tcp'</param>
        /// <param name="frontendPortRangeStart">Gets or sets the starting
        /// port range for the NAT pool. You can spcify any port number you
        /// choose, but the port numbers specified for each role in the
        /// service must be unique. Possible values range between 1 and
        /// 65535, inclusive</param>
        /// <param name="frontendPortRangeEnd">Gets or sets the ending port
        /// range for the NAT pool. You can spcify any port number you
        /// choose, but the port numbers specified for each role in the
        /// service must be unique. Possible values range between 1 and
        /// 65535, inclusive</param>
        /// <param name="backendPort">Gets or sets a port used for internal
        /// connections on the endpoint. The localPort attribute maps the
        /// eternal port of the endpoint to an internal port on a role. This
        /// is useful in scenarios where a role must communicate to an
        /// internal compotnent on a port that is different from the one that
        /// is exposed externally. If not specified, the value of localPort
        /// is the same as the port attribute. Set the value of localPort to
        /// '*' to automatically assign an unallocated port that is
        /// discoverable using the runtime API</param>
        /// <param name="frontendIPConfiguration">Gets or sets a reference to
        /// frontend IP Addresses</param>
        /// <param name="provisioningState">Gets provisioning state of the
        /// PublicIP resource Updating/Deleting/Failed</param>
        /// <param name="name">Gets name of the resource that is unique within
        /// a resource group. This name can be used to access the
        /// resource</param>
        /// <param name="etag">A unique read-only string that changes whenever
        /// the resource is updated</param>
        public InboundNatPoolInner(string protocol, int frontendPortRangeStart, int frontendPortRangeEnd, int backendPort, string id = default(string), Microsoft.Azure.Management.Resource.Fluent.SubResource frontendIPConfiguration = default(Microsoft.Azure.Management.Resource.Fluent.SubResource), string provisioningState = default(string), string name = default(string), string etag = default(string))
            : base(id)
        {
            FrontendIPConfiguration = frontendIPConfiguration;
            Protocol = protocol;
            FrontendPortRangeStart = frontendPortRangeStart;
            FrontendPortRangeEnd = frontendPortRangeEnd;
            BackendPort = backendPort;
            ProvisioningState = provisioningState;
            Name = name;
            Etag = etag;
        }

        /// <summary>
        /// Gets or sets a reference to frontend IP Addresses
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.frontendIPConfiguration")]
        public Microsoft.Azure.Management.Resource.Fluent.SubResource FrontendIPConfiguration { get; set; }

        /// <summary>
        /// Gets or sets the transport potocol for the endpoint. Possible
        /// values are Udp or Tcp. Possible values include: 'Udp', 'Tcp'
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.protocol")]
        public string Protocol { get; set; }

        /// <summary>
        /// Gets or sets the starting port range for the NAT pool. You can
        /// spcify any port number you choose, but the port numbers specified
        /// for each role in the service must be unique. Possible values
        /// range between 1 and 65535, inclusive
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.frontendPortRangeStart")]
        public int FrontendPortRangeStart { get; set; }

        /// <summary>
        /// Gets or sets the ending port range for the NAT pool. You can
        /// spcify any port number you choose, but the port numbers specified
        /// for each role in the service must be unique. Possible values
        /// range between 1 and 65535, inclusive
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.frontendPortRangeEnd")]
        public int FrontendPortRangeEnd { get; set; }

        /// <summary>
        /// Gets or sets a port used for internal connections on the endpoint.
        /// The localPort attribute maps the eternal port of the endpoint to
        /// an internal port on a role. This is useful in scenarios where a
        /// role must communicate to an internal compotnent on a port that is
        /// different from the one that is exposed externally. If not
        /// specified, the value of localPort is the same as the port
        /// attribute. Set the value of localPort to '*' to automatically
        /// assign an unallocated port that is discoverable using the runtime
        /// API
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.backendPort")]
        public int BackendPort { get; set; }

        /// <summary>
        /// Gets provisioning state of the PublicIP resource
        /// Updating/Deleting/Failed
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; set; }

        /// <summary>
        /// Gets name of the resource that is unique within a resource group.
        /// This name can be used to access the resource
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets a unique read-only string that changes whenever the
        /// resource is updated
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "etag")]
        public string Etag { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Protocol == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "Protocol");
            }
        }
    }
}
