// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Resource.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Information from validate template deployment response.
    /// </summary>
    public partial class DeploymentValidateResultInner
    {
        /// <summary>
        /// Initializes a new instance of the DeploymentValidateResultInner
        /// class.
        /// </summary>
        public DeploymentValidateResultInner() { }

        /// <summary>
        /// Initializes a new instance of the DeploymentValidateResultInner
        /// class.
        /// </summary>
        /// <param name="error">Validation error.</param>
        /// <param name="properties">The template deployment
        /// properties.</param>
        public DeploymentValidateResultInner(ResourceManagementErrorWithDetails error = default(ResourceManagementErrorWithDetails), DeploymentPropertiesExtended properties = default(DeploymentPropertiesExtended))
        {
            Error = error;
            Properties = properties;
        }

        /// <summary>
        /// Gets or sets validation error.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "error")]
        public ResourceManagementErrorWithDetails Error { get; set; }

        /// <summary>
        /// Gets or sets the template deployment properties.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties")]
        public DeploymentPropertiesExtended Properties { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (this.Error != null)
            {
                this.Error.Validate();
            }
            if (this.Properties != null)
            {
                this.Properties.Validate();
            }
        }
    }
}
