// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Storage.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// An encrypted service.
    /// </summary>
    public partial class EncryptionService
    {
        /// <summary>
        /// Initializes a new instance of the EncryptionService class.
        /// </summary>
        public EncryptionService() { }

        /// <summary>
        /// Initializes a new instance of the EncryptionService class.
        /// </summary>
        /// <param name="enabled">A boolean indicating whether or not the
        /// service is encrypted.</param>
        /// <param name="lastEnabledTime">Gets a time value indicating when
        /// was the encryption enabled by the user last time. We return this
        /// value only when encryption is enabled. There might be some
        /// unencrypted blobs which were written after this time. This time
        /// is just to give a rough estimate of when encryption was
        /// enabled.</param>
        public EncryptionService(bool? enabled = default(bool?), System.DateTime? lastEnabledTime = default(System.DateTime?))
        {
            Enabled = enabled;
            LastEnabledTime = lastEnabledTime;
        }

        /// <summary>
        /// Gets or sets a boolean indicating whether or not the service is
        /// encrypted.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "enabled")]
        public bool? Enabled { get; set; }

        /// <summary>
        /// Gets a time value indicating when was the encryption enabled by
        /// the user last time. We return this value only when encryption is
        /// enabled. There might be some unencrypted blobs which were written
        /// after this time. This time is just to give a rough estimate of
        /// when encryption was enabled.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "lastEnabledTime")]
        public System.DateTime? LastEnabledTime { get; private set; }

    }
}
